/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include "mxgpio.h"

#define BIT_INDEX_PCIE_POWER	3
#define BIT_INDEX_PCIE_RESET	1

int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE	hGPIO;
	int port_no;
	int data;
	int	nLED = 0;
	int	nRet = 0;
	int port = 0, mode = 0;
	int n = 0;

	WCHAR sin,smode;
	printf("LED Test Program\n");
    printf("\t (0) Exit Program\n");
    printf("\t (1) Set mini-PCIe Power\n");
    printf("\t (2) Set mini-PCIe Reset\n");
	
	sin = getwchar();
	n = _wtoi(&sin);
	
	do
    {
        switch (n)
        {
            // if char == '1', set the mini-PCIe Power
            case 1:
				/* Get Port Number */
				port_no = BIT_INDEX_PCIE_POWER; //_wtoi(&smode);
			
				/* Get Value */
              getwchar();
			  printf("Input the value (0:disable  1:enable) = ");
				smode = getwchar();
				data = _wtoi(&smode);
		
				/* Open device */
				hGPIO = mxgpio_open();
				
				/* Set mini-PCIe Power Signal */
				data = data == 0? 1:0; 
				nRet = mxgpio_set_data(hGPIO, port_no, data);
				
				if(nRet == -1)
				{
					printf("Set power signal fail!\n");
				}
				else
				{
					printf("Set power signal success!\n");
				}

				/* Close GPIO */
				mxgpio_close(hGPIO);
                break;

		
            // if char == '2', set the mini-PCIe Reset
            case 2:
             
				/* Get Port Number */
				port_no = BIT_INDEX_PCIE_RESET; //_wtoi(&smode);
			
				/* Get Value */
              getwchar();
              printf("Input the value (0:disable  1:enable) = ");
				smode = getwchar();
				data = _wtoi(&smode);
		
				/* Open LED */
				hGPIO = mxgpio_open();
				
				/* Set mini-PCIe Reset Signal */
				data = data == 0? 1:0; 
				nRet = mxgpio_set_data(hGPIO, port_no, data);
				
				if(nRet == -1)
				{
					printf("Set reset signal fail!\n");
				}
				else
				{
					printf("Set reset signal success!\n");
				}

				/* Close GPIO */
				mxgpio_close(hGPIO);
                break;
        }
		getwchar();
       sin = getwchar();
       n = _wtoi(&sin);
    } while (n != 0);

	return 0;
}

